//
//  ConverterController.m
//  Test
//
//  Created by Laurent on 23/12/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "WndMainController.h"
#import "Calcul.h"
#import "Model.h"

@implementation ConverterController


// Surcharge de la méthode init
- (id)init
{
    self = [super init];
    
	arrayController = [[NSArrayController alloc]init];
	
    return self;
}

//---------------------------------------------------------------------------
//		Callbacks GUI
//---------------------------------------------------------------------------

- (void)awakeFromNib
{
	//	Méthode surchargée appellée lorsque l'initialisation du NIB file est fait et opérationnelle.
	[self InitGUI];
	
	//NSRunInformationalAlertPanel(@" Laurent", @"I proud to present to you my first MacOSX application", @"OK", NULL, NULL);
}
//---------------------------------------------------------------------------
- (void)windowWillClose:(NSNotification *)note {
	
	//NSInteger retour = NSRunAlertPanel(@" Tamiya", @"OK Pour quitter l'application ou Annuler pour seulement fermer la fenêtre", @"OK", @"Annuler", NULL);
	NSInteger retour = 1;
	
	//	Annuler = 0
	if( retour == 0 ) {
		
		//	On ne quitte pas l'application, seule le fenêtre sera fermée.
		return;
	}
	//	OK = 1
	else if( retour == 1 ) {

		//	Sur fermeture de la fenête on quitte l'application:
		//	Soit cette ligne de code "compliquée"
		//[NSApp performSelector:@selector(terminate:) withObject:self afterDelay: 0.5];
		//	Soit cette ligne que je comprends un peu plus :-)
		[NSApp terminate: self ];
	}
	else {
		//	Rien d'autre à faire
	}
}
//---------------------------------------------------------------------------
/*- (void)windowDidExpose:(NSNotification *)notification {

	[super windowDidExpose:notification];
}*/
//---------------------------------------------------------------------------
- (void)controlTextDidChange:(NSNotification *)notification {
	
	NSTextField *ed = [notification object];
	
	if (ed == nsSpurSize) {
		[nsSpurSlider setIntValue:[nsSpurSize intValue]];

		[self Calculer];
	}
	
	if (ed == nsPignonSize) {

		[nsPignonSlider setIntValue:[nsPignonSize intValue]];
		[self Calculer];
	}

	if (ed == nsSpeedMoteur) {
		[self Calculer];
	}

	if (ed == nsChassisRatio) {
		[self Calculer];
	}

	if (ed == nsDiameterTire) {
		[self Calculer];
	}
}
//---------------------------------------------------------------------------

- (IBAction)ddModelSelectedItem:(id)sender {
	
	NSArray* selections = [arrayController selectedObjects];
	Model* model = [selections objectAtIndex:0];
	if( model != nil ) {
		
		[self DisplayValues:[model chassisRatio]:[model speedMoteur]:[model diameterTire]:[model spurSize]:[model pignonSize]];
		[self DisplayImageCar:[model ImageName]];
		
		[self Calculer];
	}
}
//---------------------------------------------------------------------------
//	Gestion temps réels des sliders
//---------------------------------------------------------------------------

//	Méthode appelée lors du changement de valeur du slider
- (IBAction)tbSpurSelection:(id)sender {

	[nsSpurSize setIntValue:[nsSpurSlider intValue]];
	[self Calculer];
}
//---------------------------------------------------------------------------
//	Méthode appelée lors du changement de valeur du slider
- (IBAction)tbPignonlection:(id)sender {
		
	[nsPignonSize setIntValue:[nsPignonSlider intValue]];
	[self Calculer];
}

//---------------------------------------------------------------------------
//		Implémentation
//---------------------------------------------------------------------------

- (void)InitGUI {

	[self SetPopupModels];
	
	NSArray *liste = [self->arrayController arrangedObjects];
	Model *model = [liste objectAtIndex:0];
	if(model != nil ) {
		
		[self DisplayValues:[model chassisRatio]:[model speedMoteur]:[model diameterTire]:[model spurSize]:[model pignonSize]];
		[self DisplayImageCar:[model ImageName]];	
		
		[self Calculer];
	}
}
//---------------------------------------------------------------------------
-(void) DisplayImageCar:(NSString *)imageName {
	
	NSString *filename = [NSString stringWithFormat:@"%@", imageName ];		

	//	Lire l'image du Bundle de l'application
	NSImage *image = [NSImage imageNamed: filename];
	
	[self->ivImageCar setImage:image];
	[self->ivImageCar setImageScaling:NSScaleProportionally];
}

//---------------------------------------------------------------------------
-(void) Calculer {
		
	float	chassisRatio, speedMoteur, diameterTire;
	int		spurSize, pignonSize;
	
	[self GetAllValues: &chassisRatio : &speedMoteur : &diameterTire : &spurSize : &pignonSize];

	if( spurSize > 0 && pignonSize > 0 && speedMoteur > 0 && diameterTire > 0 ) {	
		
		float resRatio = [Calcul CalculRatio:chassisRatio :spurSize :pignonSize];
		float resSpeed = [Calcul CalculSpeed:speedMoteur :diameterTire :chassisRatio :spurSize :pignonSize];
		
		[self DisplayResults:resRatio:resSpeed];
	}
}

//---------------------------------------------------------------------------
- (void)GetAllValues:(float *) aChassisRatio:(float *) aSpeedMoteur:(float *) aDiameterTire:(int *) aSpurSize:(int *) aPignonSize {
	
	*aChassisRatio = [nsChassisRatio floatValue];					//	rapport de transmission du chassis
	*aSpeedMoteur = [nsSpeedMoteur floatValue];						//	Rotation moteur Tr/min
	*aDiameterTire = [nsDiameterTire floatValue];					//	diamètres des pneus en mm
	
	*aSpurSize = [nsSpurSize intValue];								//	nombre de dents de la couronne
	*aPignonSize = [nsPignonSize intValue];							//	nombre de dents du pignon moteur
}
//---------------------------------------------------------------------------
- (void)DisplayValues:(float) aChassisRatio:(float) aSpeedMoteur:(float) aDiameterTire:(int) aSpurSize:(int) aPignonSize {
	
	[nsChassisRatio setFloatValue:aChassisRatio];					//	rapport de transmission du chassis
	[nsSpeedMoteur setFloatValue:aSpeedMoteur];						//	Rotation moteur Tr/min
	[nsDiameterTire setFloatValue:aDiameterTire];					//	diamètres des pneus en mm
	
	[nsSpurSize setIntValue:aSpurSize];								//	nombre de dents de la couronne
	[nsPignonSize setIntValue:aPignonSize];							//	nombre de dents du pignon moteur

	[nsSpurSlider setIntValue:aSpurSize];
	[nsPignonSlider setIntValue:aPignonSize];
}
//---------------------------------------------------------------------------
- (void) SetPopupModels {

	Model *itemModel;
	
	[nsPopupModel removeAllItems];
	
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"TT-01":	2.6:	65.0:	18000.0:	58.0:	24.0 ];
	[arrayController addObject:itemModel];
	[itemModel release];

	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"TB-02R":	2.6:	65.0:	28500.0:	55.0:	22.0 ];
	[arrayController addObject:itemModel];
	[itemModel release];
				
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"TRF415":	2.187:	65.0:	18000.0:	10.00:	10.00 ];
	[arrayController addObject:itemModel];
	[itemModel release];
	
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"F-201":	2.60:	65.0:	18000.0:	10.00:	10.00 ];
	[arrayController addObject:itemModel];
	[itemModel release];
	
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"TA-04":	2.133:	65.0:	18000.0:	10.00:	10.00 ];
	[arrayController addObject:itemModel];
	[itemModel release];
	
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"TBevo 2":	2.60:	65.0:	18000.0:	10.00:	10.00 ];
	[arrayController addObject:itemModel];
	[itemModel release];
	
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"TBevo 3":	2.60:	65.0:	18000.0:	10.00:	10.00 ];
	[arrayController addObject:itemModel];
	[itemModel release];
	
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"TBevo 4":	2.294:	65.0:	18000.0:	10.00:	10.00 ];
	[arrayController addObject:itemModel];
	[itemModel release];
	
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"Tamiya": @"TB01evo1":	2.60:	65.0:	18000.0:	10.00:	10.00 ];
	[arrayController addObject:itemModel];
	[itemModel release];
	
	itemModel = [[Model alloc]init];
	[itemModel InitObjet:	@"": @"Model libre":	1.0:	65.0:	18000.0:	10.00:	10.00 ];
	[arrayController addObject:itemModel];
	[itemModel release];
		
	[arrayController setSelectionIndex:0];
}
//---------------------------------------------------------------------------
- (void)DisplayResults:(float) aResRatio:(float) aResSpeed {
	
	[nsResultRatio setFloatValue:aResRatio];						//	rapport de transmission couronne/pignon
	[nsResultSpeed setFloatValue:aResSpeed];						//	vitesse calculée
}
//---------------------------------------------------------------------------
@end
